//  Copyright 2021 VMWare

#import <Foundation/Foundation.h>
#import "WS1Intelligence.h"
#import <Cordova/CDV.h>

@interface CDVWS1Intelligence : CDVPlugin

// Initialization

- (void)ws1IntelligenceInit:(CDVInvokedUrlCommand *)command;
- (void)ws1IntelligenceSetLoggingLevel:(CDVInvokedUrlCommand *)command;

// Breadcrumbs

- (void)ws1IntelligenceLeaveBreadcrumb:(CDVInvokedUrlCommand *)command;
- (void)ws1IntelligenceSetAsyncBreadcrumbMode:(CDVInvokedUrlCommand *)command;

// User Flows

- (void)ws1IntelligenceBeginUserFlow:(CDVInvokedUrlCommand *)command;
- (void)ws1IntelligenceEndUserFlow:(CDVInvokedUrlCommand *)command;
- (void)ws1IntelligenceFailUserFlow:(CDVInvokedUrlCommand *)command;
- (void)ws1IntelligenceCancelUserFlow:(CDVInvokedUrlCommand *)command;

// Exceptions

- (void)ws1IntelligenceLogHandledException:(CDVInvokedUrlCommand *)command;
- (void)ws1IntelligenceLogUnhandledException:(CDVInvokedUrlCommand *)command;

// Network Request

- (void)ws1IntelligenceLogNetworkRequest:(CDVInvokedUrlCommand *)command;

// Location

- (void)ws1IntelligenceLogLocation:(CDVInvokedUrlCommand *)command;

// Opt Out Status

- (void)ws1IntelligenceSetOptOutStatus:(CDVInvokedUrlCommand *)command;
- (void)ws1IntelligenceGetOptOutStatus:(CDVInvokedUrlCommand *)command;

// User UUID

- (void)ws1IntelligenceGetUserUUID:(CDVInvokedUrlCommand *)command;

// didCrashOnLastLoad

- (void)ws1IntelligenceDidCrashOnLastLoad:(CDVInvokedUrlCommand *)command;

// Username

- (void)ws1IntelligenceSetUsername:(CDVInvokedUrlCommand *)command;

@end
