//
//  WS1Constants.h
//  VMWare
//
//  Created by Kieran Crawford on 8/20/19.
//  Copyright © 2020 VMWare. All rights reserved.
//

#ifndef WS1Constants_h
#define WS1Constants_h

extern NSString * const WS1NotificationDidCrashOnLastLoad;
extern NSString * const WS1NotificationCrashNameKey;
extern NSString * const WS1NotificationCrashReasonKey;
extern NSString * const WS1NotificationCrashDateKey;

typedef NS_ENUM(NSInteger, WS1IntelligenceLoggingLevel) {
  WS1IntelligenceLoggingLevelSilent = 0,
  WS1IntelligenceLoggingLevelError,
  WS1IntelligenceLoggingLevelWarning,
  WS1IntelligenceLoggingLevelInfo,
  WS1IntelligenceLoggingLevelDebug,
  WS1IntelligenceLoggingLevelVerbose
};

#endif /* WS1Constants_h */

