//
//  WS1ServiceContainer.m
//  WS1ServiceRegistry
//
//  Created by Edward Yu on 8/29/18.
//  Copyright © 2018 air-watch. All rights reserved.
//

#import "WS1ServiceContainer.h"
NS_ASSUME_NONNULL_BEGIN
@implementation WS1ServiceContainer

+(instancetype)containerWithService:(id)service andIdentifier:(nonnull NSString *)identifier {
    return [[WS1ServiceContainer alloc] initWithService:service andIdentifier:identifier];
}

-(instancetype)initWithService:(id)service andIdentifier:(nonnull NSString *)identifier {
    if (self == [super init]) {
        self.service = service;
        self.identifier = identifier;
    }
    return self;
}


@end
NS_ASSUME_NONNULL_END
